#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException

from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *



class RoutingInstance(object):
  """
  Attributes:
   - name
   - uuid
   - virtual_network
   - route_targets
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'uuid', None, None, ), # 2
    (3, TType.STRING, 'virtual_network', None, None, ), # 3
    (4, TType.LIST, 'route_targets', (TType.STRING,None), None, ), # 4
  )

  def __init__(self, name=None, uuid=None, virtual_network=None, route_targets=None,):
    self.name = name
    self.uuid = uuid
    self.virtual_network = virtual_network
    self.route_targets = route_targets

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.virtual_network) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.route_targets = []
          (length, _etype3, _size0) = iprot.readListBegin()
          read_cnt += length
          for _i4 in xrange(_size0):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem5) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.route_targets.append(_elem5)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.virtual_network is not None:
      annotations = {}
      annotations['link'] = 'VirtualNetworkList'
      if oprot.writeFieldBegin('virtual_network', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.virtual_network) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.route_targets is not None:
      annotations = {}
      if oprot.writeFieldBegin('route_targets', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.route_targets)) < 0: return -1
      for iter6 in self.route_targets:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter6) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.uuid is not None:
      log_str.write('uuid = ')
      log_str.write(self.uuid)
      log_str.write('  ')
    if self.virtual_network is not None:
      log_str.write('virtual_network = ')
      log_str.write(self.virtual_network)
      log_str.write('  ')
    if self.route_targets is not None:
      log_str.write('route_targets = ')
      log_str.write('[ ')
      for iter7 in self.route_targets:
        log_str.write(iter7)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.uuid is not None:
      size += getsizeof(self.uuid)
    if self.virtual_network is not None:
      size += getsizeof(self.virtual_network)
    if self.route_targets is not None:
      size += getsizeof(self.route_targets)
      size += sum(map(getsizeof, self.route_targets))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VirtualNetwork(object):
  """
  Attributes:
   - name
   - uuid
   - routing_instances
   - virtual_machine_interfaces
   - physical_routers
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'uuid', None, None, ), # 2
    (3, TType.LIST, 'routing_instances', (TType.STRING,None), None, ), # 3
    (4, TType.LIST, 'virtual_machine_interfaces', (TType.STRING,None), None, ), # 4
    (5, TType.LIST, 'physical_routers', (TType.STRING,None), None, ), # 5
  )

  def __init__(self, name=None, uuid=None, routing_instances=None, virtual_machine_interfaces=None, physical_routers=None,):
    self.name = name
    self.uuid = uuid
    self.routing_instances = routing_instances
    self.virtual_machine_interfaces = virtual_machine_interfaces
    self.physical_routers = physical_routers

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.routing_instances = []
          (length, _etype11, _size8) = iprot.readListBegin()
          read_cnt += length
          for _i12 in xrange(_size8):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem13) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.routing_instances.append(_elem13)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.virtual_machine_interfaces = []
          (length, _etype17, _size14) = iprot.readListBegin()
          read_cnt += length
          for _i18 in xrange(_size14):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem19) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.virtual_machine_interfaces.append(_elem19)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.physical_routers = []
          (length, _etype23, _size20) = iprot.readListBegin()
          read_cnt += length
          for _i24 in xrange(_size20):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem25) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.physical_routers.append(_elem25)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.routing_instances is not None:
      annotations = {}
      if oprot.writeFieldBegin('routing_instances', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.routing_instances)) < 0: return -1
      for iter26 in self.routing_instances:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter26) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.virtual_machine_interfaces is not None:
      annotations = {}
      if oprot.writeFieldBegin('virtual_machine_interfaces', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.virtual_machine_interfaces)) < 0: return -1
      for iter27 in self.virtual_machine_interfaces:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter27) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.physical_routers is not None:
      annotations = {}
      if oprot.writeFieldBegin('physical_routers', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.physical_routers)) < 0: return -1
      for iter28 in self.physical_routers:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter28) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.uuid is not None:
      log_str.write('uuid = ')
      log_str.write(self.uuid)
      log_str.write('  ')
    if self.routing_instances is not None:
      log_str.write('routing_instances = ')
      log_str.write('[ ')
      for iter29 in self.routing_instances:
        log_str.write(iter29)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.virtual_machine_interfaces is not None:
      log_str.write('virtual_machine_interfaces = ')
      log_str.write('[ ')
      for iter30 in self.virtual_machine_interfaces:
        log_str.write(iter30)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.physical_routers is not None:
      log_str.write('physical_routers = ')
      log_str.write('[ ')
      for iter31 in self.physical_routers:
        log_str.write(iter31)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.uuid is not None:
      size += getsizeof(self.uuid)
    if self.routing_instances is not None:
      size += getsizeof(self.routing_instances)
      size += sum(map(getsizeof, self.routing_instances))
    if self.virtual_machine_interfaces is not None:
      size += getsizeof(self.virtual_machine_interfaces)
      size += sum(map(getsizeof, self.virtual_machine_interfaces))
    if self.physical_routers is not None:
      size += getsizeof(self.physical_routers)
      size += sum(map(getsizeof, self.physical_routers))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VirtualMachineInterface(object):
  """
  Attributes:
   - name
   - uuid
   - logical_interface
   - virtual_network
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'uuid', None, None, ), # 2
    (3, TType.STRING, 'logical_interface', None, None, ), # 3
    (4, TType.STRING, 'virtual_network', None, None, ), # 4
  )

  def __init__(self, name=None, uuid=None, logical_interface=None, virtual_network=None,):
    self.name = name
    self.uuid = uuid
    self.logical_interface = logical_interface
    self.virtual_network = virtual_network

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.logical_interface) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.virtual_network) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.logical_interface is not None:
      annotations = {}
      annotations['link'] = 'LogicalInterfaceList'
      if oprot.writeFieldBegin('logical_interface', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.logical_interface) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.virtual_network is not None:
      annotations = {}
      annotations['link'] = 'VirtualNetworkList'
      if oprot.writeFieldBegin('virtual_network', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.virtual_network) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.uuid is not None:
      log_str.write('uuid = ')
      log_str.write(self.uuid)
      log_str.write('  ')
    if self.logical_interface is not None:
      log_str.write('logical_interface = ')
      log_str.write(self.logical_interface)
      log_str.write('  ')
    if self.virtual_network is not None:
      log_str.write('virtual_network = ')
      log_str.write(self.virtual_network)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.uuid is not None:
      size += getsizeof(self.uuid)
    if self.logical_interface is not None:
      size += getsizeof(self.logical_interface)
    if self.virtual_network is not None:
      size += getsizeof(self.virtual_network)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LogicalInterface(object):
  """
  Attributes:
   - name
   - uuid
   - physical_interface
   - virtual_machine_interface
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'uuid', None, None, ), # 2
    (3, TType.STRING, 'physical_interface', None, None, ), # 3
    (4, TType.STRING, 'virtual_machine_interface', None, None, ), # 4
  )

  def __init__(self, name=None, uuid=None, physical_interface=None, virtual_machine_interface=None,):
    self.name = name
    self.uuid = uuid
    self.physical_interface = physical_interface
    self.virtual_machine_interface = virtual_machine_interface

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.physical_interface) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.virtual_machine_interface) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.physical_interface is not None:
      annotations = {}
      annotations['link'] = 'PhysicalInterfaceList'
      if oprot.writeFieldBegin('physical_interface', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.physical_interface) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.virtual_machine_interface is not None:
      annotations = {}
      annotations['link'] = 'VirtualMachineInterfaceList'
      if oprot.writeFieldBegin('virtual_machine_interface', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.virtual_machine_interface) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.uuid is not None:
      log_str.write('uuid = ')
      log_str.write(self.uuid)
      log_str.write('  ')
    if self.physical_interface is not None:
      log_str.write('physical_interface = ')
      log_str.write(self.physical_interface)
      log_str.write('  ')
    if self.virtual_machine_interface is not None:
      log_str.write('virtual_machine_interface = ')
      log_str.write(self.virtual_machine_interface)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.uuid is not None:
      size += getsizeof(self.uuid)
    if self.physical_interface is not None:
      size += getsizeof(self.physical_interface)
    if self.virtual_machine_interface is not None:
      size += getsizeof(self.virtual_machine_interface)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PhysicalInterface(object):
  """
  Attributes:
   - name
   - uuid
   - physical_router
   - logical_interfaces
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'uuid', None, None, ), # 2
    (3, TType.STRING, 'physical_router', None, None, ), # 3
    (4, TType.LIST, 'logical_interfaces', (TType.STRING,None), None, ), # 4
  )

  def __init__(self, name=None, uuid=None, physical_router=None, logical_interfaces=None,):
    self.name = name
    self.uuid = uuid
    self.physical_router = physical_router
    self.logical_interfaces = logical_interfaces

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.physical_router) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.logical_interfaces = []
          (length, _etype35, _size32) = iprot.readListBegin()
          read_cnt += length
          for _i36 in xrange(_size32):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem37) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.logical_interfaces.append(_elem37)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.physical_router is not None:
      annotations = {}
      annotations['link'] = 'PhysicalRouterList'
      if oprot.writeFieldBegin('physical_router', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.physical_router) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.logical_interfaces is not None:
      annotations = {}
      if oprot.writeFieldBegin('logical_interfaces', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.logical_interfaces)) < 0: return -1
      for iter38 in self.logical_interfaces:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter38) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.uuid is not None:
      log_str.write('uuid = ')
      log_str.write(self.uuid)
      log_str.write('  ')
    if self.physical_router is not None:
      log_str.write('physical_router = ')
      log_str.write(self.physical_router)
      log_str.write('  ')
    if self.logical_interfaces is not None:
      log_str.write('logical_interfaces = ')
      log_str.write('[ ')
      for iter39 in self.logical_interfaces:
        log_str.write(iter39)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.uuid is not None:
      size += getsizeof(self.uuid)
    if self.physical_router is not None:
      size += getsizeof(self.physical_router)
    if self.logical_interfaces is not None:
      size += getsizeof(self.logical_interfaces)
      size += sum(map(getsizeof, self.logical_interfaces))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PhysicalRouter(object):
  """
  Attributes:
   - name
   - uuid
   - bgp_router
   - physical_interfaces
   - logical_interfaces
   - virtual_networks
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'uuid', None, None, ), # 2
    (3, TType.STRING, 'bgp_router', None, None, ), # 3
    (4, TType.LIST, 'physical_interfaces', (TType.STRING,None), None, ), # 4
    (5, TType.LIST, 'logical_interfaces', (TType.STRING,None), None, ), # 5
    (6, TType.LIST, 'virtual_networks', (TType.STRING,None), None, ), # 6
  )

  def __init__(self, name=None, uuid=None, bgp_router=None, physical_interfaces=None, logical_interfaces=None, virtual_networks=None,):
    self.name = name
    self.uuid = uuid
    self.bgp_router = bgp_router
    self.physical_interfaces = physical_interfaces
    self.logical_interfaces = logical_interfaces
    self.virtual_networks = virtual_networks

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.bgp_router) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.physical_interfaces = []
          (length, _etype43, _size40) = iprot.readListBegin()
          read_cnt += length
          for _i44 in xrange(_size40):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem45) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.physical_interfaces.append(_elem45)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.logical_interfaces = []
          (length, _etype49, _size46) = iprot.readListBegin()
          read_cnt += length
          for _i50 in xrange(_size46):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem51) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.logical_interfaces.append(_elem51)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.LIST:
          self.virtual_networks = []
          (length, _etype55, _size52) = iprot.readListBegin()
          read_cnt += length
          for _i56 in xrange(_size52):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem57) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.virtual_networks.append(_elem57)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.bgp_router is not None:
      annotations = {}
      annotations['link'] = 'BgpRouterList'
      if oprot.writeFieldBegin('bgp_router', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.bgp_router) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.physical_interfaces is not None:
      annotations = {}
      annotations['link'] = 'PhysicalInterfaceList'
      if oprot.writeFieldBegin('physical_interfaces', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.physical_interfaces)) < 0: return -1
      for iter58 in self.physical_interfaces:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter58) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.logical_interfaces is not None:
      annotations = {}
      if oprot.writeFieldBegin('logical_interfaces', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.logical_interfaces)) < 0: return -1
      for iter59 in self.logical_interfaces:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter59) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.virtual_networks is not None:
      annotations = {}
      if oprot.writeFieldBegin('virtual_networks', TType.LIST, 6, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.virtual_networks)) < 0: return -1
      for iter60 in self.virtual_networks:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter60) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.uuid is not None:
      log_str.write('uuid = ')
      log_str.write(self.uuid)
      log_str.write('  ')
    if self.bgp_router is not None:
      log_str.write('bgp_router = ')
      log_str.write(self.bgp_router)
      log_str.write('  ')
    if self.physical_interfaces is not None:
      log_str.write('physical_interfaces = ')
      log_str.write('[ ')
      for iter61 in self.physical_interfaces:
        log_str.write(iter61)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.logical_interfaces is not None:
      log_str.write('logical_interfaces = ')
      log_str.write('[ ')
      for iter62 in self.logical_interfaces:
        log_str.write(iter62)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.virtual_networks is not None:
      log_str.write('virtual_networks = ')
      log_str.write('[ ')
      for iter63 in self.virtual_networks:
        log_str.write(iter63)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.uuid is not None:
      size += getsizeof(self.uuid)
    if self.bgp_router is not None:
      size += getsizeof(self.bgp_router)
    if self.physical_interfaces is not None:
      size += getsizeof(self.physical_interfaces)
      size += sum(map(getsizeof, self.physical_interfaces))
    if self.logical_interfaces is not None:
      size += getsizeof(self.logical_interfaces)
      size += sum(map(getsizeof, self.logical_interfaces))
    if self.virtual_networks is not None:
      size += getsizeof(self.virtual_networks)
      size += sum(map(getsizeof, self.virtual_networks))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class BgpRouter(object):
  """
  Attributes:
   - name
   - uuid
   - peers
   - physical_router
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'uuid', None, None, ), # 2
    (3, TType.LIST, 'peers', (TType.STRING,None), None, ), # 3
    (4, TType.STRING, 'physical_router', None, None, ), # 4
  )

  def __init__(self, name=None, uuid=None, peers=None, physical_router=None,):
    self.name = name
    self.uuid = uuid
    self.peers = peers
    self.physical_router = physical_router

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.peers = []
          (length, _etype67, _size64) = iprot.readListBegin()
          read_cnt += length
          for _i68 in xrange(_size64):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem69) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.peers.append(_elem69)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.physical_router) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.peers is not None:
      annotations = {}
      if oprot.writeFieldBegin('peers', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.peers)) < 0: return -1
      for iter70 in self.peers:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter70) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.physical_router is not None:
      annotations = {}
      annotations['link'] = 'PhysicalRouterList'
      if oprot.writeFieldBegin('physical_router', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.physical_router) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.uuid is not None:
      log_str.write('uuid = ')
      log_str.write(self.uuid)
      log_str.write('  ')
    if self.peers is not None:
      log_str.write('peers = ')
      log_str.write('[ ')
      for iter71 in self.peers:
        log_str.write(iter71)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.physical_router is not None:
      log_str.write('physical_router = ')
      log_str.write(self.physical_router)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.uuid is not None:
      size += getsizeof(self.uuid)
    if self.peers is not None:
      size += getsizeof(self.peers)
      size += sum(map(getsizeof, self.peers))
    if self.physical_router is not None:
      size += getsizeof(self.physical_router)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RoutingInstanceListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'routing_instances', (TType.STRUCT,(RoutingInstance, RoutingInstance.thrift_spec)), None, ), # 1
  )

  def __init__(self, routing_instances=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.routing_instances = routing_instances
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1327912381
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.routing_instances is not None:
      log_str.write('routing_instances = ')
      log_str.write('[ ')
      for iter72 in self.routing_instances:
        log_str.write('<<  ')
        log_str.write(iter72.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.routing_instances = []
          (length, _etype76, _size73) = iprot.readListBegin()
          read_cnt += length
          for _i77 in xrange(_size73):
            _elem78 = RoutingInstance()
            read_cnt += _elem78.read(iprot)
            self.routing_instances.append(_elem78)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.routing_instances is not None:
      annotations = {}
      if oprot.writeFieldBegin('routing_instances', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.routing_instances)) < 0: return -1
      for iter79 in self.routing_instances:
        if iter79.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.routing_instances != other.routing_instances:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.routing_instances is not None:
      size += getsizeof(self.routing_instances)
      size += sum(map(getsizeof, self.routing_instances))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RoutingInstanceList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name_or_uuid', None, None, ), # 1
  )

  def __init__(self, name_or_uuid=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.name_or_uuid = name_or_uuid
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = RoutingInstanceList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "RoutingInstanceList" not implemented')
    if bottle.request.query.x:
      sandesh_req.name_or_uuid = str(bottle.request.query.x)
    if bottle.request.query.name_or_uuid:
      sandesh_req.name_or_uuid = str(bottle.request.query.name_or_uuid)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "RoutingInstanceList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "RoutingInstanceList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name_or_uuid is not None:
      log_str.write('name_or_uuid = ')
      log_str.write(self.name_or_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name_or_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.name_or_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('name_or_uuid', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name_or_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.name_or_uuid != other.name_or_uuid:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name_or_uuid is not None:
      size += getsizeof(self.name_or_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VirtualNetworkListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'virtual_networks', (TType.STRUCT,(VirtualNetwork, VirtualNetwork.thrift_spec)), None, ), # 1
  )

  def __init__(self, virtual_networks=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.virtual_networks = virtual_networks
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3221924333
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.virtual_networks is not None:
      log_str.write('virtual_networks = ')
      log_str.write('[ ')
      for iter80 in self.virtual_networks:
        log_str.write('<<  ')
        log_str.write(iter80.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.virtual_networks = []
          (length, _etype84, _size81) = iprot.readListBegin()
          read_cnt += length
          for _i85 in xrange(_size81):
            _elem86 = VirtualNetwork()
            read_cnt += _elem86.read(iprot)
            self.virtual_networks.append(_elem86)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.virtual_networks is not None:
      annotations = {}
      if oprot.writeFieldBegin('virtual_networks', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.virtual_networks)) < 0: return -1
      for iter87 in self.virtual_networks:
        if iter87.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.virtual_networks != other.virtual_networks:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.virtual_networks is not None:
      size += getsizeof(self.virtual_networks)
      size += sum(map(getsizeof, self.virtual_networks))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VirtualNetworkList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name_or_uuid', None, None, ), # 1
  )

  def __init__(self, name_or_uuid=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.name_or_uuid = name_or_uuid
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = VirtualNetworkList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "VirtualNetworkList" not implemented')
    if bottle.request.query.x:
      sandesh_req.name_or_uuid = str(bottle.request.query.x)
    if bottle.request.query.name_or_uuid:
      sandesh_req.name_or_uuid = str(bottle.request.query.name_or_uuid)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "VirtualNetworkList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "VirtualNetworkList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name_or_uuid is not None:
      log_str.write('name_or_uuid = ')
      log_str.write(self.name_or_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name_or_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.name_or_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('name_or_uuid', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name_or_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.name_or_uuid != other.name_or_uuid:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name_or_uuid is not None:
      size += getsizeof(self.name_or_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VirtualMachineInterfaceListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'virtual_machine_interfaces', (TType.STRUCT,(VirtualMachineInterface, VirtualMachineInterface.thrift_spec)), None, ), # 1
  )

  def __init__(self, virtual_machine_interfaces=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.virtual_machine_interfaces = virtual_machine_interfaces
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3566863386
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.virtual_machine_interfaces is not None:
      log_str.write('virtual_machine_interfaces = ')
      log_str.write('[ ')
      for iter88 in self.virtual_machine_interfaces:
        log_str.write('<<  ')
        log_str.write(iter88.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.virtual_machine_interfaces = []
          (length, _etype92, _size89) = iprot.readListBegin()
          read_cnt += length
          for _i93 in xrange(_size89):
            _elem94 = VirtualMachineInterface()
            read_cnt += _elem94.read(iprot)
            self.virtual_machine_interfaces.append(_elem94)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.virtual_machine_interfaces is not None:
      annotations = {}
      if oprot.writeFieldBegin('virtual_machine_interfaces', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.virtual_machine_interfaces)) < 0: return -1
      for iter95 in self.virtual_machine_interfaces:
        if iter95.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.virtual_machine_interfaces != other.virtual_machine_interfaces:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.virtual_machine_interfaces is not None:
      size += getsizeof(self.virtual_machine_interfaces)
      size += sum(map(getsizeof, self.virtual_machine_interfaces))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VirtualMachineInterfaceList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name_or_uuid', None, None, ), # 1
  )

  def __init__(self, name_or_uuid=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.name_or_uuid = name_or_uuid
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = VirtualMachineInterfaceList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "VirtualMachineInterfaceList" not implemented')
    if bottle.request.query.x:
      sandesh_req.name_or_uuid = str(bottle.request.query.x)
    if bottle.request.query.name_or_uuid:
      sandesh_req.name_or_uuid = str(bottle.request.query.name_or_uuid)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "VirtualMachineInterfaceList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "VirtualMachineInterfaceList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name_or_uuid is not None:
      log_str.write('name_or_uuid = ')
      log_str.write(self.name_or_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name_or_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.name_or_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('name_or_uuid', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name_or_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.name_or_uuid != other.name_or_uuid:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name_or_uuid is not None:
      size += getsizeof(self.name_or_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LogicalInterfaceListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'logical_interfaces', (TType.STRUCT,(LogicalInterface, LogicalInterface.thrift_spec)), None, ), # 1
  )

  def __init__(self, logical_interfaces=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.logical_interfaces = logical_interfaces
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3566863386
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.logical_interfaces is not None:
      log_str.write('logical_interfaces = ')
      log_str.write('[ ')
      for iter96 in self.logical_interfaces:
        log_str.write('<<  ')
        log_str.write(iter96.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.logical_interfaces = []
          (length, _etype100, _size97) = iprot.readListBegin()
          read_cnt += length
          for _i101 in xrange(_size97):
            _elem102 = LogicalInterface()
            read_cnt += _elem102.read(iprot)
            self.logical_interfaces.append(_elem102)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.logical_interfaces is not None:
      annotations = {}
      if oprot.writeFieldBegin('logical_interfaces', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.logical_interfaces)) < 0: return -1
      for iter103 in self.logical_interfaces:
        if iter103.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.logical_interfaces != other.logical_interfaces:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.logical_interfaces is not None:
      size += getsizeof(self.logical_interfaces)
      size += sum(map(getsizeof, self.logical_interfaces))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LogicalInterfaceList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name_or_uuid', None, None, ), # 1
  )

  def __init__(self, name_or_uuid=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.name_or_uuid = name_or_uuid
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = LogicalInterfaceList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "LogicalInterfaceList" not implemented')
    if bottle.request.query.x:
      sandesh_req.name_or_uuid = str(bottle.request.query.x)
    if bottle.request.query.name_or_uuid:
      sandesh_req.name_or_uuid = str(bottle.request.query.name_or_uuid)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "LogicalInterfaceList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "LogicalInterfaceList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name_or_uuid is not None:
      log_str.write('name_or_uuid = ')
      log_str.write(self.name_or_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name_or_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.name_or_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('name_or_uuid', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name_or_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.name_or_uuid != other.name_or_uuid:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name_or_uuid is not None:
      size += getsizeof(self.name_or_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PhysicalInterfaceListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'physical_interfaces', (TType.STRUCT,(PhysicalInterface, PhysicalInterface.thrift_spec)), None, ), # 1
  )

  def __init__(self, physical_interfaces=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.physical_interfaces = physical_interfaces
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1327912381
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.physical_interfaces is not None:
      log_str.write('physical_interfaces = ')
      log_str.write('[ ')
      for iter104 in self.physical_interfaces:
        log_str.write('<<  ')
        log_str.write(iter104.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.physical_interfaces = []
          (length, _etype108, _size105) = iprot.readListBegin()
          read_cnt += length
          for _i109 in xrange(_size105):
            _elem110 = PhysicalInterface()
            read_cnt += _elem110.read(iprot)
            self.physical_interfaces.append(_elem110)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.physical_interfaces is not None:
      annotations = {}
      if oprot.writeFieldBegin('physical_interfaces', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.physical_interfaces)) < 0: return -1
      for iter111 in self.physical_interfaces:
        if iter111.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.physical_interfaces != other.physical_interfaces:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.physical_interfaces is not None:
      size += getsizeof(self.physical_interfaces)
      size += sum(map(getsizeof, self.physical_interfaces))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PhysicalInterfaceList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name_or_uuid', None, None, ), # 1
  )

  def __init__(self, name_or_uuid=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.name_or_uuid = name_or_uuid
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = PhysicalInterfaceList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "PhysicalInterfaceList" not implemented')
    if bottle.request.query.x:
      sandesh_req.name_or_uuid = str(bottle.request.query.x)
    if bottle.request.query.name_or_uuid:
      sandesh_req.name_or_uuid = str(bottle.request.query.name_or_uuid)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "PhysicalInterfaceList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "PhysicalInterfaceList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name_or_uuid is not None:
      log_str.write('name_or_uuid = ')
      log_str.write(self.name_or_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name_or_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.name_or_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('name_or_uuid', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name_or_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.name_or_uuid != other.name_or_uuid:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name_or_uuid is not None:
      size += getsizeof(self.name_or_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PhysicalRouterListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'physical_routers', (TType.STRUCT,(PhysicalRouter, PhysicalRouter.thrift_spec)), None, ), # 1
  )

  def __init__(self, physical_routers=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.physical_routers = physical_routers
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 854844993
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.physical_routers is not None:
      log_str.write('physical_routers = ')
      log_str.write('[ ')
      for iter112 in self.physical_routers:
        log_str.write('<<  ')
        log_str.write(iter112.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.physical_routers = []
          (length, _etype116, _size113) = iprot.readListBegin()
          read_cnt += length
          for _i117 in xrange(_size113):
            _elem118 = PhysicalRouter()
            read_cnt += _elem118.read(iprot)
            self.physical_routers.append(_elem118)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.physical_routers is not None:
      annotations = {}
      if oprot.writeFieldBegin('physical_routers', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.physical_routers)) < 0: return -1
      for iter119 in self.physical_routers:
        if iter119.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.physical_routers != other.physical_routers:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.physical_routers is not None:
      size += getsizeof(self.physical_routers)
      size += sum(map(getsizeof, self.physical_routers))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PhysicalRouterList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name_or_uuid', None, None, ), # 1
  )

  def __init__(self, name_or_uuid=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.name_or_uuid = name_or_uuid
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = PhysicalRouterList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "PhysicalRouterList" not implemented')
    if bottle.request.query.x:
      sandesh_req.name_or_uuid = str(bottle.request.query.x)
    if bottle.request.query.name_or_uuid:
      sandesh_req.name_or_uuid = str(bottle.request.query.name_or_uuid)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "PhysicalRouterList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "PhysicalRouterList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name_or_uuid is not None:
      log_str.write('name_or_uuid = ')
      log_str.write(self.name_or_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name_or_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.name_or_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('name_or_uuid', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name_or_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.name_or_uuid != other.name_or_uuid:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name_or_uuid is not None:
      size += getsizeof(self.name_or_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class BgpRouterListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'bgp_routers', (TType.STRUCT,(BgpRouter, BgpRouter.thrift_spec)), None, ), # 1
  )

  def __init__(self, bgp_routers=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.bgp_routers = bgp_routers
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1791127597
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.bgp_routers is not None:
      log_str.write('bgp_routers = ')
      log_str.write('[ ')
      for iter120 in self.bgp_routers:
        log_str.write('<<  ')
        log_str.write(iter120.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.bgp_routers = []
          (length, _etype124, _size121) = iprot.readListBegin()
          read_cnt += length
          for _i125 in xrange(_size121):
            _elem126 = BgpRouter()
            read_cnt += _elem126.read(iprot)
            self.bgp_routers.append(_elem126)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.bgp_routers is not None:
      annotations = {}
      if oprot.writeFieldBegin('bgp_routers', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.bgp_routers)) < 0: return -1
      for iter127 in self.bgp_routers:
        if iter127.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.bgp_routers != other.bgp_routers:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.bgp_routers is not None:
      size += getsizeof(self.bgp_routers)
      size += sum(map(getsizeof, self.bgp_routers))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class BgpRouterList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name_or_uuid', None, None, ), # 1
  )

  def __init__(self, name_or_uuid=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.name_or_uuid = name_or_uuid
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = BgpRouterList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "BgpRouterList" not implemented')
    if bottle.request.query.x:
      sandesh_req.name_or_uuid = str(bottle.request.query.x)
    if bottle.request.query.name_or_uuid:
      sandesh_req.name_or_uuid = str(bottle.request.query.name_or_uuid)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "BgpRouterList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "BgpRouterList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name_or_uuid is not None:
      log_str.write('name_or_uuid = ')
      log_str.write(self.name_or_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name_or_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.name_or_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('name_or_uuid', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name_or_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.name_or_uuid != other.name_or_uuid:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name_or_uuid is not None:
      size += getsizeof(self.name_or_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
RoutingInstanceList,
VirtualNetworkList,
VirtualMachineInterfaceList,
LogicalInterfaceList,
PhysicalInterfaceList,
PhysicalRouterList,
BgpRouterList,
]


_SANDESH_UVE_LIST = [
]


_SANDESH_ALARM_LIST = [
]
