#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException

from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *



class Acl(object):
  """
  Attributes:
   - name
   - dynamic_acl
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'dynamic_acl', None, None, ), # 2
  )

  def __init__(self, name=None, dynamic_acl=None,):
    self.name = name
    self.dynamic_acl = dynamic_acl

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.dynamic_acl) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.dynamic_acl is not None:
      annotations = {}
      if oprot.writeFieldBegin('dynamic_acl', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.dynamic_acl) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.dynamic_acl is not None:
      log_str.write('dynamic_acl = ')
      if self.dynamic_acl:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.dynamic_acl is not None:
      size += getsizeof(self.dynamic_acl)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VirtualNetwork(object):
  """
  Attributes:
   - name
   - policies
   - connections
   - routing_instances
   - acl
   - dynamic_acl
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.LIST, 'policies', (TType.STRING,None), None, ), # 2
    (3, TType.LIST, 'connections', (TType.STRING,None), None, ), # 3
    (4, TType.LIST, 'routing_instances', (TType.STRING,None), None, ), # 4
    (5, TType.STRING, 'acl', None, None, ), # 5
    (6, TType.STRING, 'dynamic_acl', None, None, ), # 6
  )

  def __init__(self, name=None, policies=None, connections=None, routing_instances=None, acl=None, dynamic_acl=None,):
    self.name = name
    self.policies = policies
    self.connections = connections
    self.routing_instances = routing_instances
    self.acl = acl
    self.dynamic_acl = dynamic_acl

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.policies = []
          (length, _etype3, _size0) = iprot.readListBegin()
          read_cnt += length
          for _i4 in xrange(_size0):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem5) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.policies.append(_elem5)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.connections = []
          (length, _etype9, _size6) = iprot.readListBegin()
          read_cnt += length
          for _i10 in xrange(_size6):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem11) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.connections.append(_elem11)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.routing_instances = []
          (length, _etype15, _size12) = iprot.readListBegin()
          read_cnt += length
          for _i16 in xrange(_size12):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem17) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.routing_instances.append(_elem17)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.STRING:
          (length, self.acl) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.STRING:
          (length, self.dynamic_acl) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.policies is not None:
      annotations = {}
      if oprot.writeFieldBegin('policies', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.policies)) < 0: return -1
      for iter18 in self.policies:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter18) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.connections is not None:
      annotations = {}
      if oprot.writeFieldBegin('connections', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.connections)) < 0: return -1
      for iter19 in self.connections:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter19) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.routing_instances is not None:
      annotations = {}
      if oprot.writeFieldBegin('routing_instances', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.routing_instances)) < 0: return -1
      for iter20 in self.routing_instances:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter20) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.acl is not None:
      annotations = {}
      if oprot.writeFieldBegin('acl', TType.STRING, 5, annotations) < 0: return -1
      if oprot.writeString(self.acl) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.dynamic_acl is not None:
      annotations = {}
      if oprot.writeFieldBegin('dynamic_acl', TType.STRING, 6, annotations) < 0: return -1
      if oprot.writeString(self.dynamic_acl) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.policies is not None:
      log_str.write('policies = ')
      log_str.write('[ ')
      for iter21 in self.policies:
        log_str.write(iter21)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.connections is not None:
      log_str.write('connections = ')
      log_str.write('[ ')
      for iter22 in self.connections:
        log_str.write(iter22)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.routing_instances is not None:
      log_str.write('routing_instances = ')
      log_str.write('[ ')
      for iter23 in self.routing_instances:
        log_str.write(iter23)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.acl is not None:
      log_str.write('acl = ')
      log_str.write(self.acl)
      log_str.write('  ')
    if self.dynamic_acl is not None:
      log_str.write('dynamic_acl = ')
      log_str.write(self.dynamic_acl)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.policies is not None:
      size += getsizeof(self.policies)
      size += sum(map(getsizeof, self.policies))
    if self.connections is not None:
      size += getsizeof(self.connections)
      size += sum(map(getsizeof, self.connections))
    if self.routing_instances is not None:
      size += getsizeof(self.routing_instances)
      size += sum(map(getsizeof, self.routing_instances))
    if self.acl is not None:
      size += getsizeof(self.acl)
    if self.dynamic_acl is not None:
      size += getsizeof(self.dynamic_acl)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RoutingInstance(object):
  """
  Attributes:
   - name
   - service_chain
   - connections
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'service_chain', None, None, ), # 2
    (3, TType.LIST, 'connections', (TType.STRING,None), None, ), # 3
  )

  def __init__(self, name=None, service_chain=None, connections=None,):
    self.name = name
    self.service_chain = service_chain
    self.connections = connections

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.service_chain) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.connections = []
          (length, _etype27, _size24) = iprot.readListBegin()
          read_cnt += length
          for _i28 in xrange(_size24):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem29) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.connections.append(_elem29)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.service_chain is not None:
      annotations = {}
      if oprot.writeFieldBegin('service_chain', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.service_chain) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.connections is not None:
      annotations = {}
      if oprot.writeFieldBegin('connections', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.connections)) < 0: return -1
      for iter30 in self.connections:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter30) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.service_chain is not None:
      log_str.write('service_chain = ')
      log_str.write(self.service_chain)
      log_str.write('  ')
    if self.connections is not None:
      log_str.write('connections = ')
      log_str.write('[ ')
      for iter31 in self.connections:
        log_str.write(iter31)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.service_chain is not None:
      size += getsizeof(self.service_chain)
    if self.connections is not None:
      size += getsizeof(self.connections)
      size += sum(map(getsizeof, self.connections))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class ServiceChain(object):
  """
  Attributes:
   - sc_name
   - left_virtual_network
   - right_virtual_network
   - direction
   - src_ports
   - dst_ports
   - service_list
   - protocol
   - created
   - error_msg
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'sc_name', None, None, ), # 1
    (2, TType.STRING, 'left_virtual_network', None, None, ), # 2
    (3, TType.STRING, 'right_virtual_network', None, None, ), # 3
    (4, TType.STRING, 'direction', None, None, ), # 4
    (5, TType.STRING, 'src_ports', None, None, ), # 5
    (6, TType.STRING, 'dst_ports', None, None, ), # 6
    (7, TType.LIST, 'service_list', (TType.STRING,None), None, ), # 7
    None, # 8
    (9, TType.STRING, 'protocol', None, None, ), # 9
    (10, TType.BOOL, 'created', None, None, ), # 10
    (11, TType.STRING, 'error_msg', None, None, ), # 11
  )

  def __init__(self, sc_name=None, left_virtual_network=None, right_virtual_network=None, direction=None, src_ports=None, dst_ports=None, service_list=None, protocol=None, created=None, error_msg=None,):
    self.sc_name = sc_name
    self.left_virtual_network = left_virtual_network
    self.right_virtual_network = right_virtual_network
    self.direction = direction
    self.src_ports = src_ports
    self.dst_ports = dst_ports
    self.service_list = service_list
    self.protocol = protocol
    self.created = created
    self.error_msg = error_msg

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.sc_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.left_virtual_network) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.right_virtual_network) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.direction) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.STRING:
          (length, self.src_ports) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.STRING:
          (length, self.dst_ports) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.LIST:
          self.service_list = []
          (length, _etype35, _size32) = iprot.readListBegin()
          read_cnt += length
          for _i36 in xrange(_size32):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem37) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.service_list.append(_elem37)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.STRING:
          (length, self.protocol) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.BOOL:
          (length, self.created) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.STRING:
          (length, self.error_msg) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.sc_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('sc_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.sc_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.left_virtual_network is not None:
      annotations = {}
      if oprot.writeFieldBegin('left_virtual_network', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.left_virtual_network) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.right_virtual_network is not None:
      annotations = {}
      if oprot.writeFieldBegin('right_virtual_network', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.right_virtual_network) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.direction is not None:
      annotations = {}
      if oprot.writeFieldBegin('direction', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.direction) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.src_ports is not None:
      annotations = {}
      if oprot.writeFieldBegin('src_ports', TType.STRING, 5, annotations) < 0: return -1
      if oprot.writeString(self.src_ports) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.dst_ports is not None:
      annotations = {}
      if oprot.writeFieldBegin('dst_ports', TType.STRING, 6, annotations) < 0: return -1
      if oprot.writeString(self.dst_ports) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.service_list is not None:
      annotations = {}
      if oprot.writeFieldBegin('service_list', TType.LIST, 7, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.service_list)) < 0: return -1
      for iter38 in self.service_list:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter38) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.protocol is not None:
      annotations = {}
      if oprot.writeFieldBegin('protocol', TType.STRING, 9, annotations) < 0: return -1
      if oprot.writeString(self.protocol) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.created is not None:
      annotations = {}
      if oprot.writeFieldBegin('created', TType.BOOL, 10, annotations) < 0: return -1
      if oprot.writeBool(self.created) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.error_msg is not None:
      annotations = {}
      if oprot.writeFieldBegin('error_msg', TType.STRING, 11, annotations) < 0: return -1
      if oprot.writeString(self.error_msg) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.sc_name is not None:
      log_str.write('sc_name = ')
      log_str.write(self.sc_name)
      log_str.write('  ')
    if self.left_virtual_network is not None:
      log_str.write('left_virtual_network = ')
      log_str.write(self.left_virtual_network)
      log_str.write('  ')
    if self.right_virtual_network is not None:
      log_str.write('right_virtual_network = ')
      log_str.write(self.right_virtual_network)
      log_str.write('  ')
    if self.direction is not None:
      log_str.write('direction = ')
      log_str.write(self.direction)
      log_str.write('  ')
    if self.src_ports is not None:
      log_str.write('src_ports = ')
      log_str.write(self.src_ports)
      log_str.write('  ')
    if self.dst_ports is not None:
      log_str.write('dst_ports = ')
      log_str.write(self.dst_ports)
      log_str.write('  ')
    if self.service_list is not None:
      log_str.write('service_list = ')
      log_str.write('[ ')
      for iter39 in self.service_list:
        log_str.write(iter39)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.protocol is not None:
      log_str.write('protocol = ')
      log_str.write(self.protocol)
      log_str.write('  ')
    if self.created is not None:
      log_str.write('created = ')
      if self.created:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.error_msg is not None:
      log_str.write('error_msg = ')
      log_str.write(self.error_msg)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.sc_name is not None:
      size += getsizeof(self.sc_name)
    if self.left_virtual_network is not None:
      size += getsizeof(self.left_virtual_network)
    if self.right_virtual_network is not None:
      size += getsizeof(self.right_virtual_network)
    if self.direction is not None:
      size += getsizeof(self.direction)
    if self.src_ports is not None:
      size += getsizeof(self.src_ports)
    if self.dst_ports is not None:
      size += getsizeof(self.dst_ports)
    if self.service_list is not None:
      size += getsizeof(self.service_list)
      size += sum(map(getsizeof, self.service_list))
    if self.protocol is not None:
      size += getsizeof(self.protocol)
    if self.created is not None:
      size += getsizeof(self.created)
    if self.error_msg is not None:
      size += getsizeof(self.error_msg)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RefList(object):
  """
  Attributes:
   - object_type
   - object_fq_name
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'object_type', None, None, ), # 1
    (2, TType.LIST, 'object_fq_name', (TType.STRING,None), None, ), # 2
  )

  def __init__(self, object_type=None, object_fq_name=None,):
    self.object_type = object_type
    self.object_fq_name = object_fq_name

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.object_type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.object_fq_name = []
          (length, _etype43, _size40) = iprot.readListBegin()
          read_cnt += length
          for _i44 in xrange(_size40):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem45) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.object_fq_name.append(_elem45)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.object_type is not None:
      annotations = {}
      annotations['link'] = 'StObject'
      if oprot.writeFieldBegin('object_type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.object_type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.object_fq_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('object_fq_name', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.object_fq_name)) < 0: return -1
      for iter46 in self.object_fq_name:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter46) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.object_type is not None:
      log_str.write('object_type = ')
      log_str.write(self.object_type)
      log_str.write('  ')
    if self.object_fq_name is not None:
      log_str.write('object_fq_name = ')
      log_str.write('[ ')
      for iter47 in self.object_fq_name:
        log_str.write(iter47)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.object_type is not None:
      size += getsizeof(self.object_type)
    if self.object_fq_name is not None:
      size += getsizeof(self.object_fq_name)
      size += sum(map(getsizeof, self.object_fq_name))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PropList(object):
  """
  Attributes:
   - property_name
   - property
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'property_name', None, None, ), # 1
    (2, TType.STRING, 'property', None, None, ), # 2
  )

  def __init__(self, property_name=None, property=None,):
    self.property_name = property_name
    self.property = property

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.property_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.property) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.property_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('property_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.property_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.property is not None:
      annotations = {}
      if oprot.writeFieldBegin('property', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.property) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.property_name is not None:
      log_str.write('property_name = ')
      log_str.write(self.property_name)
      log_str.write('  ')
    if self.property is not None:
      log_str.write('property = ')
      log_str.write(self.property)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.property_name is not None:
      size += getsizeof(self.property_name)
    if self.property is not None:
      size += getsizeof(self.property)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class StObject(object):
  """
  Attributes:
   - object_type
   - object_uuid
   - object_fq_name
   - obj_refs
   - properties
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'object_type', None, None, ), # 1
    (2, TType.STRING, 'object_uuid', None, None, ), # 2
    (3, TType.STRING, 'object_fq_name', None, None, ), # 3
    (4, TType.LIST, 'obj_refs', (TType.STRUCT,(RefList, RefList.thrift_spec)), None, ), # 4
    (5, TType.LIST, 'properties', (TType.STRUCT,(PropList, PropList.thrift_spec)), None, ), # 5
  )

  def __init__(self, object_type=None, object_uuid=None, object_fq_name=None, obj_refs=None, properties=None,):
    self.object_type = object_type
    self.object_uuid = object_uuid
    self.object_fq_name = object_fq_name
    self.obj_refs = obj_refs
    self.properties = properties

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.object_type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.object_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.object_fq_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.obj_refs = []
          (length, _etype51, _size48) = iprot.readListBegin()
          read_cnt += length
          for _i52 in xrange(_size48):
            _elem53 = RefList()
            read_cnt += _elem53.read(iprot)
            self.obj_refs.append(_elem53)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.properties = []
          (length, _etype57, _size54) = iprot.readListBegin()
          read_cnt += length
          for _i58 in xrange(_size54):
            _elem59 = PropList()
            read_cnt += _elem59.read(iprot)
            self.properties.append(_elem59)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.object_type is not None:
      annotations = {}
      if oprot.writeFieldBegin('object_type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.object_type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.object_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('object_uuid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.object_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.object_fq_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('object_fq_name', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.object_fq_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.obj_refs is not None:
      annotations = {}
      if oprot.writeFieldBegin('obj_refs', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.obj_refs)) < 0: return -1
      for iter60 in self.obj_refs:
        if iter60.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.properties is not None:
      annotations = {}
      if oprot.writeFieldBegin('properties', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.properties)) < 0: return -1
      for iter61 in self.properties:
        if iter61.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.object_type is not None:
      log_str.write('object_type = ')
      log_str.write(self.object_type)
      log_str.write('  ')
    if self.object_uuid is not None:
      log_str.write('object_uuid = ')
      log_str.write(self.object_uuid)
      log_str.write('  ')
    if self.object_fq_name is not None:
      log_str.write('object_fq_name = ')
      log_str.write(self.object_fq_name)
      log_str.write('  ')
    if self.obj_refs is not None:
      log_str.write('obj_refs = ')
      log_str.write('[ ')
      for iter62 in self.obj_refs:
        log_str.write('<<  ')
        log_str.write(iter62.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.properties is not None:
      log_str.write('properties = ')
      log_str.write('[ ')
      for iter63 in self.properties:
        log_str.write('<<  ')
        log_str.write(iter63.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.object_type is not None:
      size += getsizeof(self.object_type)
    if self.object_uuid is not None:
      size += getsizeof(self.object_uuid)
    if self.object_fq_name is not None:
      size += getsizeof(self.object_fq_name)
    if self.obj_refs is not None:
      size += getsizeof(self.obj_refs)
      size += sum(map(getsizeof, self.obj_refs))
    if self.properties is not None:
      size += getsizeof(self.properties)
      size += sum(map(getsizeof, self.properties))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VnList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'vn_name', None, None, ), # 1
  )

  def __init__(self, vn_name=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.vn_name = vn_name
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = VnList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "VnList" not implemented')
    if bottle.request.query.x:
      sandesh_req.vn_name = str(bottle.request.query.x)
    if bottle.request.query.vn_name:
      sandesh_req.vn_name = str(bottle.request.query.vn_name)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "VnList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "VnList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.vn_name is not None:
      log_str.write('vn_name = ')
      log_str.write(self.vn_name)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.vn_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.vn_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('vn_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.vn_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.vn_name != other.vn_name:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.vn_name is not None:
      size += getsizeof(self.vn_name)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class VnListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'vn_names', (TType.STRUCT,(VirtualNetwork, VirtualNetwork.thrift_spec)), None, ), # 1
  )

  def __init__(self, vn_names=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.vn_names = vn_names
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3880202517
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.vn_names is not None:
      log_str.write('vn_names = ')
      log_str.write('[ ')
      for iter64 in self.vn_names:
        log_str.write('<<  ')
        log_str.write(iter64.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.vn_names = []
          (length, _etype68, _size65) = iprot.readListBegin()
          read_cnt += length
          for _i69 in xrange(_size65):
            _elem70 = VirtualNetwork()
            read_cnt += _elem70.read(iprot)
            self.vn_names.append(_elem70)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.vn_names is not None:
      annotations = {}
      if oprot.writeFieldBegin('vn_names', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.vn_names)) < 0: return -1
      for iter71 in self.vn_names:
        if iter71.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.vn_names != other.vn_names:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.vn_names is not None:
      size += getsizeof(self.vn_names)
      size += sum(map(getsizeof, self.vn_names))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RoutingInstanceListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'routing_instances', (TType.STRUCT,(RoutingInstance, RoutingInstance.thrift_spec)), None, ), # 1
  )

  def __init__(self, routing_instances=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.routing_instances = routing_instances
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3867525951
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.routing_instances is not None:
      log_str.write('routing_instances = ')
      log_str.write('[ ')
      for iter72 in self.routing_instances:
        log_str.write('<<  ')
        log_str.write(iter72.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.routing_instances = []
          (length, _etype76, _size73) = iprot.readListBegin()
          read_cnt += length
          for _i77 in xrange(_size73):
            _elem78 = RoutingInstance()
            read_cnt += _elem78.read(iprot)
            self.routing_instances.append(_elem78)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.routing_instances is not None:
      annotations = {}
      if oprot.writeFieldBegin('routing_instances', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.routing_instances)) < 0: return -1
      for iter79 in self.routing_instances:
        if iter79.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.routing_instances != other.routing_instances:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.routing_instances is not None:
      size += getsizeof(self.routing_instances)
      size += sum(map(getsizeof, self.routing_instances))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RoutintInstanceList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'vn_name', None, None, ), # 1
    (2, TType.STRING, 'ri_name', None, None, ), # 2
  )

  def __init__(self, vn_name=None, ri_name=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.vn_name = vn_name
    self.ri_name = ri_name
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1600235783
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = RoutintInstanceList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "RoutintInstanceList" not implemented')
    if bottle.request.query.x:
      sandesh_req.vn_name = str(bottle.request.query.x)
    if bottle.request.query.vn_name:
      sandesh_req.vn_name = str(bottle.request.query.vn_name)
    if bottle.request.query.ri_name:
      sandesh_req.ri_name = str(bottle.request.query.ri_name)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "RoutintInstanceList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "RoutintInstanceList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.vn_name is not None:
      log_str.write('vn_name = ')
      log_str.write(self.vn_name)
      log_str.write('  ')
    if self.ri_name is not None:
      log_str.write('ri_name = ')
      log_str.write(self.ri_name)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.vn_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.ri_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.vn_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('vn_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.vn_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ri_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('ri_name', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.ri_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.vn_name != other.vn_name:
      return False
    if self.ri_name != other.ri_name:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.vn_name is not None:
      size += getsizeof(self.vn_name)
    if self.ri_name is not None:
      size += getsizeof(self.ri_name)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class ServiceChainListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'service_chains', (TType.STRUCT,(ServiceChain, ServiceChain.thrift_spec)), None, ), # 1
  )

  def __init__(self, service_chains=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.service_chains = service_chains
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 2271117638
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.service_chains is not None:
      log_str.write('service_chains = ')
      log_str.write('[ ')
      for iter80 in self.service_chains:
        log_str.write('<<  ')
        log_str.write(iter80.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.service_chains = []
          (length, _etype84, _size81) = iprot.readListBegin()
          read_cnt += length
          for _i85 in xrange(_size81):
            _elem86 = ServiceChain()
            read_cnt += _elem86.read(iprot)
            self.service_chains.append(_elem86)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.service_chains is not None:
      annotations = {}
      if oprot.writeFieldBegin('service_chains', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.service_chains)) < 0: return -1
      for iter87 in self.service_chains:
        if iter87.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.service_chains != other.service_chains:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.service_chains is not None:
      size += getsizeof(self.service_chains)
      size += sum(map(getsizeof, self.service_chains))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class ServiceChainList(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'sc_name', None, None, ), # 1
  )

  def __init__(self, sc_name=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.sc_name = sc_name
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = ServiceChainList()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "ServiceChainList" not implemented')
    if bottle.request.query.x:
      sandesh_req.sc_name = str(bottle.request.query.x)
    if bottle.request.query.sc_name:
      sandesh_req.sc_name = str(bottle.request.query.sc_name)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "ServiceChainList" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "ServiceChainList"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.sc_name is not None:
      log_str.write('sc_name = ')
      log_str.write(self.sc_name)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.sc_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.sc_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('sc_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.sc_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.sc_name != other.sc_name:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.sc_name is not None:
      size += getsizeof(self.sc_name)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class StObjectReq(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'object_type', None, None, ), # 1
    (2, TType.STRING, 'object_id_or_fq_name', None, None, ), # 2
  )

  def __init__(self, object_type=None, object_id_or_fq_name=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.object_type = object_type
    self.object_id_or_fq_name = object_id_or_fq_name
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1600235783
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = StObjectReq()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "StObjectReq" not implemented')
    if bottle.request.query.x:
      sandesh_req.object_type = str(bottle.request.query.x)
    if bottle.request.query.object_type:
      sandesh_req.object_type = str(bottle.request.query.object_type)
    if bottle.request.query.object_id_or_fq_name:
      sandesh_req.object_id_or_fq_name = str(bottle.request.query.object_id_or_fq_name)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "StObjectReq" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "StObjectReq"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.object_type is not None:
      log_str.write('object_type = ')
      log_str.write(self.object_type)
      log_str.write('  ')
    if self.object_id_or_fq_name is not None:
      log_str.write('object_id_or_fq_name = ')
      log_str.write(self.object_id_or_fq_name)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.object_type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.object_id_or_fq_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.object_type is not None:
      annotations = {}
      if oprot.writeFieldBegin('object_type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.object_type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.object_id_or_fq_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('object_id_or_fq_name', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.object_id_or_fq_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.object_type != other.object_type:
      return False
    if self.object_id_or_fq_name != other.object_id_or_fq_name:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.object_type is not None:
      size += getsizeof(self.object_type)
    if self.object_id_or_fq_name is not None:
      size += getsizeof(self.object_id_or_fq_name)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class StObjectListResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.LIST, 'objects', (TType.STRUCT,(StObject, StObject.thrift_spec)), None, ), # 1
  )

  def __init__(self, objects=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.objects = objects
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3292117542
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.objects is not None:
      log_str.write('objects = ')
      log_str.write('[ ')
      for iter88 in self.objects:
        log_str.write('<<  ')
        log_str.write(iter88.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.LIST:
          self.objects = []
          (length, _etype92, _size89) = iprot.readListBegin()
          read_cnt += length
          for _i93 in xrange(_size89):
            _elem94 = StObject()
            read_cnt += _elem94.read(iprot)
            self.objects.append(_elem94)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.objects is not None:
      annotations = {}
      if oprot.writeFieldBegin('objects', TType.LIST, 1, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.objects)) < 0: return -1
      for iter95 in self.objects:
        if iter95.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.objects != other.objects:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.objects is not None:
      size += getsizeof(self.objects)
      size += sum(map(getsizeof, self.objects))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
VnList,
RoutintInstanceList,
ServiceChainList,
StObjectReq,
]


_SANDESH_UVE_LIST = [
]


_SANDESH_ALARM_LIST = [
]
